--------------------------------------------------------------------------------
-- Module Tool: Tool_01.lua
-- Name: PEST: Pattern Editor Specific Templates
-- Version: 1.0b
-- Author: ulneiz (Spain)
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- INSTRUMENTS INFO
--------------------------------------------------------------------------------

--[[ Instruments------------------------------------------------------

<< SYMPHONY ORCHESTRA______________
String family--
  solo_string, first_violins, second_violins, violas, cellos, basses

Woodwind family--
  flute, piccolo, oboe, english_horn, clarinet, bass_clarinet, bassoon, recorder, contrabassoon, saxophone, bagpipe, harmonica, shakuhachi, cornet

Brass family--
  trumpet, french_horn, trombone, tuba

Keyboard and Harp--
  piano, organ, synthesizer, harp, harpsichord, celesta, accordion

Percussion family--
  timpani, snare_drum, bass_drum, tenor_drumbs, cymbals, congas, tubular bells, triangle, tambourine, xylophone, glockenspiel, wooden-block, claves, chimes, marimba, vibraphone (vibes), maracas, castanets...

Voice Types--
  soprano, mezzo-soprano, alto (contralto) | countertenor, tenor, baritone, bass

Chorus--
  mixed_voices, women's_voices, men's_voices, children's_voices


<< ROCK/POP/HEAVY BAND______________
  voice 1, voice 2, voices, chorus, 
  acoustic guitarr, electric guitarr 1, electric guitarr 2, bass guitar, contrabass guitar
  drum kit: high-hat, tom-tom, cymbal, drumsticks, snare_drum, bass_drum
  piano, synthesizer
]]


--------------------------------------------------------------------------------
-- GROUP SETTINGS AND TRACK SETTINGS
--------------------------------------------------------------------------------

class 'PEST' --

--Colors (16 x 9): AQ , BK , BL , BR , GL , GY , GR , OR , PL , PN , PS , RD , SK , VL , WH , YL
PEST.TR = {
  CR_AQ00={ 0x2C,0xB2,0xA2 }, CR_AQ01={ 0x27,0x9E,0x90 }, CR_AQ02={ 0x22,0x89,0x7D }, CR_AQ03={ 0x1D,0x75,0x6B }, CR_AQ04={ 0x18,0x60,0x58 }, CR_AQ05={ 0x13,0x4C,0x45 }, CR_AQ06={ 0x0E,0x38,0x33 }, CR_AQ07={ 0x08,0x23,0x20 }, CR_AQ08={ 0x03,0x0F,0x0D },
  CR_BK00={ 0x00,0x00,0x00 }, CR_BK01={ 0x0A,0x0A,0x0A }, CR_BK02={ 0x14,0x14,0x14 }, CR_BK03={ 0x1E,0x1E,0x1E }, CR_BK04={ 0x28,0x28,0x28 }, CR_BK05={ 0x33,0x33,0x33 }, CR_BK06={ 0x3D,0x3D,0x3D }, CR_BK07={ 0x47,0x47,0x47 }, CR_BK08={ 0x51,0x51,0x51 },
  CR_BL00={ 0x00,0x60,0xFF }, CR_BL01={ 0x00,0x57,0xE5 }, CR_BL02={ 0x00,0x4E,0xCC }, CR_BL03={ 0x00,0x44,0xB2 }, CR_BL04={ 0x00,0x3A,0x99 }, CR_BL05={ 0x00,0x30,0x7F }, CR_BL06={ 0x00,0x27,0x66 }, CR_BL07={ 0x00,0x1D,0x4C }, CR_BL08={ 0x00,0x13,0x33 },
  CR_BR00={ 0xAD,0x5C,0x11 }, CR_BR01={ 0x99,0x51,0x0F }, CR_BR02={ 0x84,0x46,0x0D }, CR_BR03={ 0x70,0x3C,0x0B }, CR_BR04={ 0x60,0x33,0x09 }, CR_BR05={ 0x4C,0x28,0x07 }, CR_BR06={ 0x38,0x1E,0x05 }, CR_BR07={ 0x23,0x13,0x03 }, CR_BR08={ 0x0F,0x08,0x01 },
  CR_GL00={ 0xFF,0xB5,0x23 }, CR_GL01={ 0xE5,0xA0,0x20 }, CR_GL02={ 0xCC,0x8E,0x1C }, CR_GL03={ 0xB2,0x7C,0x18 }, CR_GL04={ 0x99,0x6A,0x15 }, CR_GL05={ 0x7F,0x59,0x11 }, CR_GL06={ 0x66,0x47,0x0E }, CR_GL07={ 0x4C,0x35,0x0A }, CR_GL08={ 0x33,0x23,0x07 },
  CR_GY00={ 0x80,0x80,0x80 }, CR_GY01={ 0x70,0x70,0x70 }, CR_GY02={ 0x60,0x60,0x60 }, CR_GY03={ 0x51,0x51,0x51 }, CR_GY04={ 0x42,0x42,0x42 }, CR_GY05={ 0x33,0x33,0x33 }, CR_GY06={ 0x23,0x23,0x23 }, CR_GY07={ 0x19,0x19,0x19 }, CR_GY08={ 0x0F,0x0F,0x0F },
  CR_GR00={ 0x00,0xFF,0x00 }, CR_GR01={ 0x00,0xE5,0x00 }, CR_GR02={ 0x00,0xCC,0x00 }, CR_GR03={ 0x00,0xB2,0x00 }, CR_GR04={ 0x00,0x99,0x00 }, CR_GR05={ 0x00,0x7F,0x00 }, CR_GR06={ 0x00,0x66,0x00 }, CR_GR07={ 0x00,0x4C,0x00 }, CR_GR08={ 0x00,0x33,0x00 },
  CR_OR00={ 0xFF,0x80,0x00 }, CR_OR01={ 0xE5,0x72,0x00 }, CR_OR02={ 0xCC,0x66,0x00 }, CR_OR03={ 0xB2,0x59,0x00 }, CR_OR04={ 0x99,0x4C,0x00 }, CR_OR05={ 0x7F,0x3F,0x00 }, CR_OR06={ 0x66,0x33,0x00 }, CR_OR07={ 0x4C,0x26,0x00 }, CR_OR08={ 0x33,0x19,0x00 },
  CR_PL00={ 0xFF,0xA8,0xE3 }, CR_PL01={ 0xE5,0x97,0xCC }, CR_PL02={ 0xCC,0x86,0xB6 }, CR_PL03={ 0xB2,0x75,0x97 }, CR_PL04={ 0x99,0x64,0x88 }, CR_PL05={ 0x7F,0x54,0x71 }, CR_PL06={ 0x66,0x43,0x5B }, CR_PL07={ 0x4C,0x32,0x44 }, CR_PL08={ 0x33,0x21,0x2D },
  CR_PN00={ 0xFF,0x00,0xAA }, CR_PN01={ 0xE5,0x00,0x99 }, CR_PN02={ 0xCC,0x00,0x88 }, CR_PN03={ 0xB2,0x00,0x77 }, CR_PN04={ 0x99,0x00,0x66 }, CR_PN05={ 0x7F,0x00,0x55 }, CR_PN06={ 0x66,0x00,0x44 }, CR_PN07={ 0x4C,0x00,0x33 }, CR_PN08={ 0x33,0x00,0x22 },
  CR_PS00={ 0x80,0xFF,0x95 }, CR_PS01={ 0x75,0xE5,0x85 }, CR_PS02={ 0x68,0xCC,0x77 }, CR_PS03={ 0x5B,0xB2,0x68 }, CR_PS04={ 0x4E,0x99,0x59 }, CR_PS05={ 0x41,0x7F,0x4A }, CR_PS06={ 0x34,0x66,0x3B }, CR_PS07={ 0x27,0x4C,0x2C }, CR_PS08={ 0x1A,0x33,0x1D },
  CR_RD00={ 0xFF,0x00,0x00 }, CR_RD01={ 0xE5,0x00,0x00 }, CR_RD02={ 0xCC,0x00,0x00 }, CR_RD03={ 0xB2,0x00,0x00 }, CR_RD04={ 0x99,0x00,0x00 }, CR_RD05={ 0x7F,0x00,0x00 }, CR_RD06={ 0x66,0x00,0x00 }, CR_RD07={ 0x4C,0x00,0x00 }, CR_RD08={ 0x33,0x00,0x00 },
  CR_SK00={ 0x00,0xCB,0xFF }, CR_SK01={ 0x00,0xB7,0xE5 }, CR_SK02={ 0x00,0xA3,0xCC }, CR_SK03={ 0x00,0x9B,0xC1 }, CR_SK04={ 0x00,0x8E,0xB2 }, CR_SK05={ 0x00,0x7A,0x99 }, CR_SK06={ 0x00,0x65,0x7F }, CR_SK07={ 0x00,0x51,0x66 }, CR_SK08={ 0x00,0x3D,0x4C },
  CR_VL00={ 0x8C,0x00,0xFF }, CR_VL01={ 0xA8,0x00,0xE5 }, CR_VL02={ 0x95,0x00,0xCC }, CR_VL03={ 0x82,0x00,0xB2 }, CR_VL04={ 0x70,0x00,0x99 }, CR_VL05={ 0x5D,0x00,0x7F }, CR_VL06={ 0x4A,0x00,0x66 }, CR_VL07={ 0x38,0x00,0x4C }, CR_VL08={ 0x25,0x00,0x33 },
  CR_WH00={ 0xFF,0xFF,0xFF }, CR_WH01={ 0xEA,0xEA,0xEA }, CR_WH02={ 0xD6,0xD6,0xD6 }, CR_WH03={ 0xC1,0xC1,0xC1 }, CR_WH04={ 0xAD,0xAD,0xAD }, CR_WH05={ 0x99,0x99,0x99 }, CR_WH06={ 0x84,0x84,0x84 }, CR_WH07={ 0x70,0x70,0x70 }, CR_WH08={ 0x5B,0x5B,0x5B },
  CR_YL00={ 0xFF,0xFF,0x00 }, CR_YL01={ 0xE5,0xE5,0x00 }, CR_YL02={ 0xCC,0xCC,0x00 }, CR_YL03={ 0xB2,0xB2,0x00 }, CR_YL04={ 0x99,0x99,0x00 }, CR_YL05={ 0x7F,0x7F,0x00 }, CR_YL06={ 0x66,0x66,0x00 }, CR_YL07={ 0x4C,0x4C,0x00 }, CR_YL08={ 0x33,0x33,0x00 }
}


--group_setting

  --song.tracks[ song.selected_track_index     ].collapsed              = true --from the group collapse FXg only
  --song.tracks[ song.selected_track_index - 1 ].group_parent.collapsed = true --from the track son collapse FXg only
  --song.tracks[ song.selected_track_index     ].group_collapsed        = true --from the group collapse entire group

local group = {}
  group.strings        = { name='STRING GROUP'         , color=PEST.TR.CR_RD00, color_blend=30 } --RD     --collapsed = true or group_collapsed = true --collapse entire group
  group.woodwinds      = { name='WOODWINDS GROUP'      , color=PEST.TR.CR_WH00, color_blend=30 } --WH
  group.brass          = { name='BRASS GROUP'          , color=PEST.TR.CR_GL00, color_blend=30 } --GL
  group.keyboards      = { name='KEYBOARDS GROUP'      , color=PEST.TR.CR_GR00, color_blend=30 } --GR
    group.pianos       = { name='PIANOS GROUP'         , color=PEST.TR.CR_GR00, color_blend=30 } --GR
    group.synthesizers = { name='SYNTHESIZERS GROUP'   , color=PEST.TR.CR_GR00, color_blend=30 } --GR
  group.voices         = { name='VOICES GROUP'         , color=PEST.TR.CR_VL00, color_blend=30 } --VL
  group.chorus         = { name='CHORUS GROUP'         , color=PEST.TR.CR_PN00, color_blend=30 } --PN
  group.percussion     = { name='PERCUSSION GROUP'     , color=PEST.TR.CR_BL00, color_blend=30 } --BL
    group.percussion1  = { name='PERCUSSION I GROUP'   , color=PEST.TR.CR_BL00, color_blend=30 } --BL
    group.percussion2  = { name='PERCUSSION II GROUP'  , color=PEST.TR.CR_BL00, color_blend=30 } --BL
    group.percussion3  = { name='PERCUSSION III GROUP' , color=PEST.TR.CR_BL00, color_blend=30 } --BL
  group.bigpercussion  = { name='PERCUSSION III GROUP' , color=PEST.TR.CR_AQ00, color_blend=30 } --AQ

  group.xxx            = { name='STRING GROUP'         , color=PEST.TR.CR_RD00, color_blend=30 }
  group.xxx            = { name='STRING GROUP'         , color=PEST.TR.CR_RD00, color_blend=30 }
  group.xxx            = { name='STRING GROUP'         , color=PEST.TR.CR_RD00, color_blend=30 }
  group.xxx            = { name='STRING GROUP'         , color=PEST.TR.CR_RD00, color_blend=30 }
  group.xxx            = { name='STRING GROUP'         , color=PEST.TR.CR_RD00, color_blend=30 }
  group.xxx            = { name='STRING GROUP'         , color=PEST.TR.CR_RD00, color_blend=30 }
  group.xxx            = { name='STRING GROUP'         , color=PEST.TR.CR_RD00, color_blend=30 }


--track_setting
local track = {}                --'___________' -- ideal size           --color_blend=00-100

--SYMPHONY ORCHESTRA INSTRUMENTS-----------------------------------------------------------------
----Strings
  track.solostring     = { name='Solo String'    , color=PEST.TR.CR_RD01, color_blend=15 }
  track.firstviolins   = { name='1st Violins'    , color=PEST.TR.CR_RD02, color_blend=15 }
  track.secondviolins  = { name='2nd Violins'    , color=PEST.TR.CR_RD03, color_blend=15 }
  track.violas         = { name='Violas'         , color=PEST.TR.CR_RD04, color_blend=15 }
  track.cellos         = { name='Cellos'         , color=PEST.TR.CR_RD05, color_blend=15 }
  track.basses         = { name='Basses'         , color=PEST.TR.CR_RD06, color_blend=15 }
----Woodwinds
  track.solowoodwind   = { name='Solo Woodwind'  , color=PEST.TR.CR_WH01, color_blend=15 }
  track.flute          = { name='Flute'          , color=PEST.TR.CR_WH02, color_blend=15 }
  track.oboe           = { name='Oboe'           , color=PEST.TR.CR_WH03, color_blend=15 }
  track.piccolo        = { name='Piccolo'        , color=PEST.TR.CR_WH04, color_blend=15 }
  track.englishhorn    = { name='English Horn'   , color=PEST.TR.CR_WH05, color_blend=15 }
  --
  track.bassclarinet   = { name='Bass Clarinet'  , color=PEST.TR.CR_WH01, color_blend=15 }
  track.clarinet       = { name='Clarinet'       , color=PEST.TR.CR_WH02, color_blend=15 }
  track.contrabasson   = { name='Contrabasson'   , color=PEST.TR.CR_WH03, color_blend=15 }
  track.basson         = { name='Basson'         , color=PEST.TR.CR_WH04, color_blend=15 }
  --
  track.bagpipe        = { name='Bagpipe'        , color=PEST.TR.CR_WH01, color_blend=15 }
  track.shakuhachi     = { name='Shakuhachi'     , color=PEST.TR.CR_WH02, color_blend=15 }
  track.cornet         = { name='Cornet'         , color=PEST.TR.CR_WH03, color_blend=15 }
  track.harmonica      = { name='Harmonica'      , color=PEST.TR.CR_WH04, color_blend=15 }
----Brass
  track.solobrass      = { name='Solo Brass'     , color=PEST.TR.CR_GL01, color_blend=15 }
  track.trumpets       = { name='Trumpets'       , color=PEST.TR.CR_GL02, color_blend=15 }
  track.trombones      = { name='Trombones'      , color=PEST.TR.CR_GL03, color_blend=15 }
  track.tuba           = { name='Tuba'           , color=PEST.TR.CR_GL04, color_blend=15 }
  track.frenchhorns    = { name='French Horns'   , color=PEST.TR.CR_GL05, color_blend=15 }
  track.saxophone      = { name='Saxophone'      , color=PEST.TR.CR_GL06, color_blend=15 }
----Keyboards
  track.harp           = { name='Harp'           , color=PEST.TR.CR_GR01, color_blend=15 }
  track.piano          = { name='Piano'          , color=PEST.TR.CR_GR02, color_blend=15 }
  track.pianol         = { name='Piano Left'     , color=PEST.TR.CR_GR03, color_blend=15 }
  track.pianoc         = { name='Piano Center'   , color=PEST.TR.CR_GR04, color_blend=15 }
  track.pianor         = { name='Piano Right'    , color=PEST.TR.CR_GR05, color_blend=15 }
  track.piano1         = { name='Piano I'        , color=PEST.TR.CR_GR03, color_blend=15 }
  track.piano2         = { name='Piano II'       , color=PEST.TR.CR_GR04, color_blend=15 }
  track.piano3         = { name='Piano III'      , color=PEST.TR.CR_GR05, color_blend=15 }
  track.synthesizer    = { name='Synthesizer'    , color=PEST.TR.CR_GR03, color_blend=15 }
  track.synthesizer1   = { name='Synth I'        , color=PEST.TR.CR_GR04, color_blend=15 }
  track.synthesizer2   = { name='Synth II'       , color=PEST.TR.CR_GR05, color_blend=15 }
  track.synthesizer3   = { name='Synth III'      , color=PEST.TR.CR_GR06, color_blend=15 }
  track.organ          = { name='Organ'          , color=PEST.TR.CR_GR04, color_blend=15 }
  track.harpsichord    = { name='Harpsichord'    , color=PEST.TR.CR_GR05, color_blend=15 }
  track.celesta        = { name='Celesta'        , color=PEST.TR.CR_GR06, color_blend=15 }
  track.accordion      = { name='Accordion'      , color=PEST.TR.CR_GR07, color_blend=15 }
----Voices
  track.soprano        = { name='Soprano'        , color=PEST.TR.CR_VL01, color_blend=15 }
  track.mezzosoprano   = { name='Mezzo-Soprano'  , color=PEST.TR.CR_VL02, color_blend=15 }
  track.contralto      = { name='Contralto'      , color=PEST.TR.CR_VL03, color_blend=15 }
  track.countertenor   = { name='Countertenor'   , color=PEST.TR.CR_VL04, color_blend=15 }
  track.tenor          = { name='Tenor'          , color=PEST.TR.CR_VL05, color_blend=15 }
  track.baritone       = { name='Baritone'       , color=PEST.TR.CR_VL06, color_blend=15 }
  track.bassvoice      = { name='Bass Voice'     , color=PEST.TR.CR_VL07, color_blend=15 }
----Chorus
  track.mixedvoices    = { name='Mixed Voices'   , color=PEST.TR.CR_PN01, color_blend=15 }
  track.womenvoices    = { name='Women Voices'   , color=PEST.TR.CR_PN02, color_blend=15 }
  track.menvoices      = { name='Men Voices'     , color=PEST.TR.CR_PN03, color_blend=15 }
  track.childrenvoices = { name='Children Voices', color=PEST.TR.CR_PN04, color_blend=15 }
----Percussion
  track.tubularbells   = { name='Tubular Bells'  , color=PEST.TR.CR_BL01, color_blend=15 }
  track.vibraphone     = { name='Vibraphone'     , color=PEST.TR.CR_BL02, color_blend=15 }
  track.xylophone      = { name='Xylophone'      , color=PEST.TR.CR_BL03, color_blend=15 }
  track.glockenspiel   = { name='Glockenspiel'   , color=PEST.TR.CR_BL04, color_blend=15 }
  track.marimba        = { name='Marimba'        , color=PEST.TR.CR_BL05, color_blend=15 }
  track.hammer         = { name='Hammer'         , color=PEST.TR.CR_BL06, color_blend=15 }
  track.triangle       = { name='Triangle'       , color=PEST.TR.CR_BL07, color_blend=15 }
  track.chimes         = { name='Chimes'         , color=PEST.TR.CR_BL08, color_blend=15 }
  --
  track.maracas        = { name='Maracas'        , color=PEST.TR.CR_BL01, color_blend=15 }
  track.castanets      = { name='Castanets'      , color=PEST.TR.CR_BL02, color_blend=15 }
  track.woodenblock    = { name='Wooden-block'   , color=PEST.TR.CR_BL03, color_blend=15 }
  track.claves         = { name='Claves'         , color=PEST.TR.CR_BL04, color_blend=15 }
  track.tambourine     = { name='Tambourine'     , color=PEST.TR.CR_BL05, color_blend=15 }
  --
  track.cymbals        = { name='Cymbals'        , color=PEST.TR.CR_BL01, color_blend=15 }
  track.snaredrum      = { name='Snare Drum'     , color=PEST.TR.CR_BL02, color_blend=15 }
  track.gong           = { name='Gong'           , color=PEST.TR.CR_BL03, color_blend=15 }
  track.timpani        = { name='Timpani'        , color=PEST.TR.CR_BL04, color_blend=15 }
  track.congas         = { name='Congas'         , color=PEST.TR.CR_BL05, color_blend=15 }
  track.tenordrum      = { name='Tenor Drum'     , color=PEST.TR.CR_BL06, color_blend=15 }
  track.bassdrum       = { name='Bass Drum'      , color=PEST.TR.CR_BL07, color_blend=15 }
  --
  track.bigbass        = { name='Big Bass'       , color=PEST.TR.CR_AQ01, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color=PEST.TR.CR_AQ02, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color=PEST.TR.CR_AQ03, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color=PEST.TR.CR_AQ04, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color=PEST.TR.CR_AQ05, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color=PEST.TR.CR_AQ06, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color=PEST.TR.CR_AQ07, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color=PEST.TR.CR_AQ08, color_blend=15 }

--BAND POP/ROCK/HEAVY INSTRUMENTS-----------------------------------------------------------------
-----Voices
  track.voice1           = { name='Voice I'           , color=PEST.TR.CR_RD06, color_blend=15 }
  track.voice2           = { name='Voice II'          , color=PEST.TR.CR_RD06, color_blend=15 }
  track.voices           = { name='Voices'            , color=PEST.TR.CR_RD06, color_blend=15 }
-----Guitars
  track.acousticguitar   = { name='Acoustic Guitar'   , color=PEST.TR.CR_RD06, color_blend=15 }
  track.electricguitar1  = { name='Electric Guitar I' , color=PEST.TR.CR_RD06, color_blend=15 }
  track.electricguitar2  = { name='Electric Guitar II', color=PEST.TR.CR_RD06, color_blend=15 }  
  track.bassguitar       = { name='Bass Guitar'       , color=PEST.TR.CR_RD06, color_blend=15 }
  track.contrabassguitar = { name='Contrabass Guitar' , color=PEST.TR.CR_RD06, color_blend=15 }
----Keyboards
  --track.piano          = { name='Piano'             , color=PEST.TR.CR_RD06, color_blend=15 }
  --track.synthesizer1   = { name='Synth I'           , color=PEST.TR.CR_RD06, color_blend=15 }
  --track.synthesizer2   = { name='Synth II'          , color=PEST.TR.CR_RD06, color_blend=15 }
  --track.synthesizer3   = { name='Synth III'         , color=PEST.TR.CR_RD06, color_blend=15 }    
---- Drum Kit
  track.bassdrum2        = { name='Bass Drum'         , color=PEST.TR.CR_RD06, color_blend=15 }
  track.floortom         = { name='Floor Tom'         , color=PEST.TR.CR_RD06, color_blend=15 }
  track.snaredrum2       = { name='Snare Drum'        , color=PEST.TR.CR_RD06, color_blend=15 }
  track.hangingtombs     = { name='Hanging tombs'     , color=PEST.TR.CR_RD06, color_blend=15 }
  track.hihat            = { name='Hi-hat'            , color=PEST.TR.CR_RD06, color_blend=15 }
  track.crashcymbal      = { name='Crash Cymbal'      , color=PEST.TR.CR_RD06, color_blend=15 }
  track.ridecymbal       = { name='Ride Cymbal'       , color=PEST.TR.CR_RD06, color_blend=15 }
  track.splashcymbal     = { name='Splash Cymbal'     , color=PEST.TR.CR_RD06, color_blend=15 }
  track.chinacymbal      = { name='China Cymbal'      , color=PEST.TR.CR_RD06, color_blend=15 }

--ELECTRONIC/NEW AGE INSTRUMENTS------------------------------------------------------------------
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color=PEST.TR.CR_RD06, color_blend=15 }

  --- ---
  group.x00              = { name='ggg          ', color=PEST.TR.CR_AQ00, color_blend=30 }
  track.x01              = { name='xxx          ', color=PEST.TR.CR_AQ01, color_blend=15 }
  track.x02              = { name='xxx          ', color=PEST.TR.CR_AQ02, color_blend=15 }
  track.x03              = { name='xxx          ', color=PEST.TR.CR_AQ03, color_blend=15 }
  track.x04              = { name='xxx          ', color=PEST.TR.CR_AQ04, color_blend=15 }
  track.x05              = { name='xxx          ', color=PEST.TR.CR_AQ05, color_blend=15 }
  track.x06              = { name='xxx          ', color=PEST.TR.CR_AQ06, color_blend=15 }
  track.x07              = { name='xxx          ', color=PEST.TR.CR_AQ07, color_blend=15 }
  track.x08              = { name='xxx          ', color=PEST.TR.CR_AQ08, color_blend=15 }

  


--------------------------------------------------------------------------------
-- CHECKBOX & VALUEBOX CONTROL
--------------------------------------------------------------------------------
function show_trntc(i) --valuebox visible_note_columns (1-12)
  for n,v in pairs(track) do
    v.visible_note_columns = i
  end
end

function show_trvol(i) --checkbox volume_column_visible (True/False)
  for n,v in pairs(track) do
    v.volume_column_visible = i
  end
end

function show_trpan(i) --checkbox panning_column_visible (True/False)
  for n,v in pairs(track) do
    v.panning_column_visible = i
  end
end

function show_trdly(i) --checkbox delay_column_visible (True/False)
  for n,v in pairs(track) do
    v.delay_column_visible = i
  end
end

function show_trsfx(i) --checkbox sample_effects_column_visible (True/False)
  for n,v in pairs(track) do
    v.sample_effects_column_visible = i
  end
end

function show_trfxt(i) --valuebox visible_effect_columns (0-8)
  for n,v in pairs(track) do
    v.visible_effect_columns = i
  end
end

--[[

function show_grfxg(i) --group_collapsed (True/False)
  for n,v in pairs(group) do
    --v.group_collapsed = i
    v.collapsed = i
  end
end

]]

VALUEBOX_PEST_TRNTC = vb:valuebox { id = 'vbox_pest_trntc', value = 1, notifier = function(i) show_trntc(i) end, tooltip = 'Note Column Track', width = 50, height = 22, min = 1, max = 12 }
--CHECKBOX_PEST_TRVOL = vb:checkbox { id = 'cbox_pest_trvol', value = true,   notifier = function(i) show_trvol(i) end, tooltip = 'Volume Column Track' }
--CHECKBOX_PEST_TRPAN = vb:checkbox { id = 'cbox_pest_trpan', value = false,  notifier = function(i) show_trpan(i) end, tooltip = 'Panning Column Track' }
--CHECKBOX_PEST_TRDLY = vb:checkbox { id = 'cbox_pest_trdly', value = false,  notifier = function(i) show_trdly(i) end, tooltip = 'Delay Column Track' }
--CHECKBOX_PEST_TRSFX = vb:checkbox { id = 'cbox_pest_trsfx', value = false,  notifier = function(i) show_trsfx(i) end, tooltip = 'Sfx Column Track' }
VALUEBOX_PEST_TRFXT = vb:valuebox { id = 'vbox_pest_trfxt', value = 0,      notifier = function(i) show_trfxt(i) end, tooltip = 'FXt Column Track', width = 50, height = 22, min = 0, max = 8 }

--CHECKBOX_PEST_GRFXG = vb:checkbox { id = 'cbox_pest_grfxg', value = false,  notifier = function(i) show_grfxg(i) end, tooltip = 'GXtg Column Group' }

--[[
BUTTONCHECK_PEST_TRVOL = vb:button {
  id = 'expand_button',
  width = 40,
  height = 24,
  text = 'VOL',
  color = {00 , 60 , 00 },
  notifier = function()
    if vb.views['cbox_pest_trvol'].value == false then
      vb.views['cbox_pest_trvol'].value = true
      vb.views['expand_button'].color = { 00 , 60 , 00 }
      --vb.views['expand_button'].text = 'VOL'
      --settings.popout_visible.value = true
      --settings.popout_height.value = 134
      else
      vb.views['cbox_pest_trvol'].value = false
      vb.views['expand_button'].color = { 60 , 00 , 00 }
      --vb.views['expand_button'].text = 'VOL'
      -- settings.popout_visible.value = false
      -- settings.popout_height.value = 1
    end
  end
}
]]

vb:checkbox { id = 'cbox_pest_trvol', notifier = function(i) show_trvol(i) end, value = true } --Buttoncheck VOL
BUTTONCHECK_PEST_TRVOL = vb:button {
  id = 'beck_pest_trvol',
  width = 40,
  height = 22,
  text = 'VOL',
  color = {0x00 , 0x70 , 0x00 },
  notifier = function()
    if vb.views['cbox_pest_trvol'].value == false then
       vb.views['cbox_pest_trvol'].value = true
       vb.views['beck_pest_trvol'].color = { 0x00 , 0x70 , 0x00 }
      else
       vb.views['cbox_pest_trvol'].value = false
       vb.views['beck_pest_trvol'].color = { 0x50 , 0x00 , 0x00 }
    end
  end
}

vb:checkbox { id = 'cbox_pest_trpan', notifier = function(i) show_trpan(i) end, value = false } --Buttoncheck VOL
BUTTONCHECK_PEST_TRPAN = vb:button {
  id = 'beck_pest_trpan',
  width = 40,
  height = 22,
  text = 'PAN',
  color = {0x50 , 0x00 , 0x00 },
  notifier = function()
    if vb.views['cbox_pest_trpan'].value == false then
       vb.views['cbox_pest_trpan'].value = true
       vb.views['beck_pest_trpan'].color = { 0x00 , 0x70 , 0x00 }
      else
       vb.views['cbox_pest_trpan'].value = false
       vb.views['beck_pest_trpan'].color = { 0x50 , 0x00 , 0x00 }
    end
  end
}

vb:checkbox { id = 'cbox_pest_trdly', notifier = function(i) show_trdly(i) end, value = false } --Buttoncheck VOL
BUTTONCHECK_PEST_TRDLY = vb:button {
  id = 'beck_pest_trdly',
  width = 40,
  height = 22,
  text = 'DLY',
  color = {0x50 , 0x00 , 0x00 },
  notifier = function()
    if vb.views['cbox_pest_trdly'].value == false then
       vb.views['cbox_pest_trdly'].value = true
       vb.views['beck_pest_trdly'].color = { 0x00 , 0x70 , 0x00 }
      else
       vb.views['cbox_pest_trdly'].value = false
       vb.views['beck_pest_trdly'].color = { 0x50 , 0x00 , 0x00 }
    end
  end
}

vb:checkbox { id = 'cbox_pest_trsfx', notifier = function(i) show_trsfx(i) end, value = false } --Buttoncheck VOL
BUTTONCHECK_PEST_TRSFX = vb:button {
  id = 'beck_pest_trsfx',
  width = 40,
  height = 22,
  text = 'sFX',
  color = {0x50 , 0x00 , 0x00 },
  notifier = function()
    if vb.views['cbox_pest_trsfx'].value == false then
       vb.views['cbox_pest_trsfx'].value = true
       vb.views['beck_pest_trsfx'].color = { 0x00 , 0x70 , 0x00 }
      else
       vb.views['cbox_pest_trsfx'].value = false
       vb.views['beck_pest_trsfx'].color = { 0x50 , 0x00 , 0x00 }
    end
  end
}

DEFAULT_PEST_PARAM = vb:button {
  id = 'def_pest_param',
  width = 28,
  height = 22,
  text = 'DF',
  tooltip = 'Default Values Configuration.',
  color = { 0x00 , 0x20 , 0x50 },
  notifier = function()
    if vb.views['cbox_pest_trvol'].value == false then
       vb.views['cbox_pest_trvol'].value = true
       vb.views['beck_pest_trvol'].color = { 0x00 , 0x70 , 0x00 }
       else
       vb.views['cbox_pest_trvol'].value = true
       vb.views['beck_pest_trvol'].color = { 0x00 , 0x70 , 0x00 }
    end

    if vb.views['cbox_pest_trpan'].value == true then
       vb.views['cbox_pest_trpan'].value = false
       vb.views['beck_pest_trpan'].color = { 0x50 , 0x00 , 0x00 }
       else
       vb.views['cbox_pest_trpan'].value = false
       vb.views['beck_pest_trpan'].color = { 0x50 , 0x00 , 0x00 }
    end       
    if vb.views['cbox_pest_trdly'].value == true then
       vb.views['cbox_pest_trdly'].value = false
       vb.views['beck_pest_trdly'].color = { 0x50 , 0x00 , 0x00 }
       else
       vb.views['cbox_pest_trdly'].value = false
       vb.views['beck_pest_trdly'].color = { 0x50 , 0x00 , 0x00 }
    end
    if vb.views['cbox_pest_trsfx'].value == true then
       vb.views['cbox_pest_trsfx'].value = false
       vb.views['beck_pest_trsfx'].color = { 0x50 , 0x00 , 0x00 }
       else
       vb.views['cbox_pest_trsfx'].value = false
       vb.views['beck_pest_trsfx'].color = { 0x50 , 0x00 , 0x00 }       
    end
    
    if vb.views['vbox_pest_trntc'].value > 0 then
       vb.views['vbox_pest_trntc'].value = 1
       else
       vb.views['vbox_pest_trntc'].value = 1
    end
    if vb.views['vbox_pest_trfxt'].value >= 0 then
       vb.views['vbox_pest_trfxt'].value = 0
       else
       vb.views['vbox_pest_trfxt'].value = 0
    end
  end
}


--------------------------------------------------------------------------------
-- INSERT GROUP, INSERT TRACK/S & ADD TRACKS TO GROUP
--------------------------------------------------------------------------------
--Insert Group Only
function in_gr( tid , group_setting )
  local song = renoise.song()
  local tid = song.selected_track_index + 1
  song:insert_group_at( tid )
  for parameter_name , parameter_value in pairs( group_setting ) do
    song:track( tid )[ parameter_name ] = parameter_value
  end
  song:select_next_track()
end
--Collapse Group (FXg only)
function coll_gr()
  local song = renoise.song()
  song.tracks[ song.selected_track_index ].collapsed = true -- collapse the FXg in group selected
  --song.tracks[ song.selected_track_index - 1 ].group_parent.collapsed = true  -- collapse FXg in group parent
  --song.tracks[ song.selected_track_index ].group_collapsed = true -- collapse all group
end

--Insert Track Only
function in_tr( tid , track_setting )
  local song = renoise.song()
  local tid = song.selected_track_index + 1
  song:insert_track_at( tid ) --insert a track
  local tr = song:track( tid ) --define "tr"
  tr.visible_note_columns, tr.volume_column_visible, tr.panning_column_visible, tr.delay_column_visible, tr.sample_effects_column_visible, tr.visible_effect_columns = 1, T, F, F, F, 0  --config global parameters tr (checkboxes)
  for parameter_name, parameter_value in pairs( track_setting ) do -- config specific parameters tr ( name, color, color_blend )
    song:track( tid )[ parameter_name ] = parameter_value
  end
  song.selected_track_index = tid --select the track
end

--Insert Tracks in Group
function in_tr_gr_x1() -- x01
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
end

function in_tr_gr_x2() -- x02
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
end

function in_tr_gr_x3() -- x03
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )  
end

function in_tr_gr_x4() -- x04
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
end

function in_tr_gr_x5() -- x05
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
end

function in_tr_gr_x6() -- x06
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
end
function in_tr_gr_x7() -- x07
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
end

function in_tr_gr_x8() -- x08
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
end

function in_tr_gr_x9() -- x09
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
end

function in_tr_gr_x10() -- x10
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
end

function in_tr_gr_x11() -- x11
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
end

function in_tr_gr_x12() -- x12
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
end

function in_tr_gr_x13() -- x13
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
end

function in_tr_gr_x14() -- x14
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
end

function in_tr_gr_x15() -- x15
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
end

function in_tr_gr_x16() -- x16
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
end

function in_tr_gr_x17() -- x17
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
  song:add_track_to_group( tid -17, tid )
end

function in_tr_gr_x18() -- x18
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
  song:add_track_to_group( tid -17, tid )
  song:add_track_to_group( tid -18, tid )
end

function in_tr_gr_x19() -- x19
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
  song:add_track_to_group( tid -17, tid )
  song:add_track_to_group( tid -18, tid )
  song:add_track_to_group( tid -19, tid )
end

function in_tr_gr_x20() -- x20
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
  song:add_track_to_group( tid -17, tid )
  song:add_track_to_group( tid -18, tid )
  song:add_track_to_group( tid -19, tid )
  song:add_track_to_group( tid -20, tid )
end

function in_tr_gr_x21() -- x21
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
  song:add_track_to_group( tid -17, tid )
  song:add_track_to_group( tid -18, tid )
  song:add_track_to_group( tid -19, tid )
  song:add_track_to_group( tid -20, tid )
  song:add_track_to_group( tid -21, tid )
end

function in_tr_gr_x22() -- x22
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
  song:add_track_to_group( tid -17, tid )
  song:add_track_to_group( tid -18, tid )
  song:add_track_to_group( tid -19, tid )
  song:add_track_to_group( tid -20, tid )
  song:add_track_to_group( tid -21, tid )
  song:add_track_to_group( tid -22, tid )
end

function in_tr_gr_x23() -- x23
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
  song:add_track_to_group( tid -17, tid )
  song:add_track_to_group( tid -18, tid )
  song:add_track_to_group( tid -19, tid )
  song:add_track_to_group( tid -20, tid )
  song:add_track_to_group( tid -21, tid )
  song:add_track_to_group( tid -22, tid )
  song:add_track_to_group( tid -23, tid )
end

function in_tr_gr_x24() -- x24
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
  song:add_track_to_group( tid -17, tid )
  song:add_track_to_group( tid -18, tid )
  song:add_track_to_group( tid -19, tid )
  song:add_track_to_group( tid -20, tid )
  song:add_track_to_group( tid -21, tid )
  song:add_track_to_group( tid -22, tid )
  song:add_track_to_group( tid -23, tid )
  song:add_track_to_group( tid -24, tid )
end

function in_tr_gr_x25() -- x25
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
  song:add_track_to_group( tid -17, tid )
  song:add_track_to_group( tid -18, tid )
  song:add_track_to_group( tid -19, tid )
  song:add_track_to_group( tid -20, tid )
  song:add_track_to_group( tid -21, tid )
  song:add_track_to_group( tid -22, tid )
  song:add_track_to_group( tid -23, tid )
  song:add_track_to_group( tid -24, tid )
  song:add_track_to_group( tid -25, tid )
end

function in_tr_gr_x26() -- x26
  local song = renoise.song()
  local tid = song.selected_track_index
  song:add_track_to_group( tid - 1, tid )
  song:add_track_to_group( tid - 2, tid )
  song:add_track_to_group( tid - 3, tid )
  song:add_track_to_group( tid - 4, tid )
  song:add_track_to_group( tid - 5, tid )
  song:add_track_to_group( tid - 6, tid )
  song:add_track_to_group( tid - 7, tid )
  song:add_track_to_group( tid - 8, tid )
  song:add_track_to_group( tid - 9, tid )
  song:add_track_to_group( tid -10, tid )
  song:add_track_to_group( tid -11, tid )
  song:add_track_to_group( tid -12, tid )
  song:add_track_to_group( tid -13, tid )
  song:add_track_to_group( tid -14, tid )
  song:add_track_to_group( tid -15, tid )
  song:add_track_to_group( tid -16, tid )
  song:add_track_to_group( tid -17, tid )
  song:add_track_to_group( tid -18, tid )
  song:add_track_to_group( tid -19, tid )
  song:add_track_to_group( tid -20, tid )
  song:add_track_to_group( tid -21, tid )
  song:add_track_to_group( tid -22, tid )
  song:add_track_to_group( tid -23, tid )
  song:add_track_to_group( tid -24, tid )
  song:add_track_to_group( tid -25, tid )
  song:add_track_to_group( tid -26, tid )
end


--------------------------------------------------------------------------------
-- FUNCTIONS FOR POPUPS (Per Indiviual - Per Groups - Per All)
--------------------------------------------------------------------------------
--Symphony Orchestra Instruments (Per Individual - A01)
--Strings
function pest_fn_A01_01()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.solostring )
end

function pest_fn_A01_02()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.firstviolins )
end

function pest_fn_A01_03()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.secondviolins )
end

function pest_fn_A01_04()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.violas )
end

function pest_fn_A01_05()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.cellos )
end

function pest_fn_A01_06()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.basses )
end
--Woodwinds
function pest_fn_A01_07()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.solowoodwind )
end

function pest_fn_A01_08()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.flute )
end

function pest_fn_A01_09()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.oboe )
end

function pest_fn_A01_10()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.piccolo )
end

function pest_fn_A01_11()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.englishhorn )
end

function pest_fn_A01_12()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.bassclarinet )
end

function pest_fn_A01_13()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.clarinet )
end

function pest_fn_A01_14()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.contrabasson )
end

function pest_fn_A01_15()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.basson )
end

function pest_fn_A01_16()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.bagpipe )
end

function pest_fn_A01_17()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.shakuhachi )
end



function pest_fn_A01_18()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.cornet )
end

function pest_fn_A01_19()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.harmonica )
end
--Brasses
function pest_fn_A01_20()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.solobrass )
end

function pest_fn_A01_21()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.trumpets )
end

function pest_fn_A01_22()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.trombones )
end

function pest_fn_A01_23()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.tuba )
end

function pest_fn_A01_24()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.frenchhorns )
end

function pest_fn_A01_25()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.saxophone )
end
--Keyboard
function pest_fn_A01_26()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.harp )
end

function pest_fn_A01_27()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.piano )
end

function pest_fn_A01_28()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.synthesizer )
end

function pest_fn_A01_29()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.organ )
end

function pest_fn_A01_30()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.harpsichord )
end

function pest_fn_A01_31()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.celesta )
end

function pest_fn_A01_32()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.accordion )
end
--Voices
function pest_fn_A01_33()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.soprano )
end

function pest_fn_A01_34()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.mezzosoprano )
end

function pest_fn_A01_35()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.contralto )
end

function pest_fn_A01_36()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.countertenor )
end

function pest_fn_A01_37()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.tenor )
end

function pest_fn_A01_38()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.baritone )
end

function pest_fn_A01_39()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.bassvoice )
end
--Chorus
function pest_fn_A01_40()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.mixedvoices )
end

function pest_fn_A01_41()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.womenvoices )
end

function pest_fn_A01_42()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.menvoices )
end

function pest_fn_A01_43()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.childrenvoices )
end
--Percussion
function pest_fn_A01_44()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.tubularbells )
end

function pest_fn_A01_45()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.vibraphone )
end

function pest_fn_A01_46()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.xylophone )
end

function pest_fn_A01_47()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.glockenspiel )
end

function pest_fn_A01_48()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.marimba )
end

function pest_fn_A01_49()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.hammer )
end

function pest_fn_A01_50()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.triangle )
end

function pest_fn_A01_51()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.chimes )
end

function pest_fn_A01_52()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.maracas )
end

function pest_fn_A01_53()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.castanets )
end

function pest_fn_A01_54()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.woodenblock )
end

function pest_fn_A01_55()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.claves )
end

function pest_fn_A01_56()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.tambourine )
end

function pest_fn_A01_57()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.cymbals )
end

function pest_fn_A01_58()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.snaredrum )
end

function pest_fn_A01_59()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.gong )
end

function pest_fn_A01_60()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.timpani )
end

function pest_fn_A01_61()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.congas )
end

function pest_fn_A01_62()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.tenordrum )
end

function pest_fn_A01_63()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.bassdrum )
end

-----------------------------------------------------------------------------------

--Symphony Orchestra Sections
function pest_fn_A02_01() --Strings Basic
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.basses )
  in_tr( tid , track.cellos )
  in_tr( tid , track.violas )
  in_tr( tid , track.secondviolins )
  in_tr( tid , track.firstviolins )
  in_tr( tid , track.solostring )
  in_gr( tid , group.strings )
  in_tr_gr_x6()
  coll_gr()
end
--- --- ---
function pest_fn_A02_02() --Strings Expanded
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.basses )
  in_tr( tid , track.basses )
  in_tr( tid , track.cellos )
  in_tr( tid , track.cellos )
  in_tr( tid , track.violas )
  in_tr( tid , track.violas )
  in_tr( tid , track.secondviolins )
  in_tr( tid , track.secondviolins )
  in_tr( tid , track.firstviolins )
  in_tr( tid , track.firstviolins )
  in_tr( tid , track.solostring )
  in_tr( tid , track.solostring )
  in_gr( tid , group.strings )
  in_tr_gr_x12()
  coll_gr()
end
--- --- ---
function pest_fn_A02_03() --Woodwinds Basic
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.harmonica )
  in_tr( tid , track.cornet )
  in_tr( tid , track.shakuhachi )
  in_tr( tid , track.bagpipe )
  in_tr( tid , track.basson )  
  in_tr( tid , track.contrabasson )
  in_tr( tid , track.clarinet )
  in_tr( tid , track.bassclarinet )
  in_tr( tid , track.englishhorn )
  in_tr( tid , track.piccolo )
  in_tr( tid , track.oboe )
  in_tr( tid , track.flute )
  in_tr( tid , track.solowoodwind )
  in_gr( tid , group.woodwinds )
  in_tr_gr_x13()
  coll_gr()
end
--- --- ---
function pest_fn_A02_04() --Woodwinds Expanded
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.harmonica )
  in_tr( tid , track.cornet )
  in_tr( tid , track.shakuhachi )
  in_tr( tid , track.shakuhachi )
  in_tr( tid , track.bagpipe )
  in_tr( tid , track.bagpipe )
  in_tr( tid , track.basson )
  in_tr( tid , track.basson )
  in_tr( tid , track.contrabasson )
  in_tr( tid , track.contrabasson )
  in_tr( tid , track.clarinet )
  in_tr( tid , track.clarinet )
  in_tr( tid , track.bassclarinet )
  in_tr( tid , track.bassclarinet )
  in_tr( tid , track.englishhorn )
  in_tr( tid , track.englishhorn )
  in_tr( tid , track.piccolo )
  in_tr( tid , track.piccolo )
  in_tr( tid , track.oboe )
  in_tr( tid , track.oboe )
  in_tr( tid , track.flute )
  in_tr( tid , track.flute )
  in_tr( tid , track.solowoodwind )
  in_tr( tid , track.solowoodwind )
  in_gr( tid , group.woodwinds )
  in_tr_gr_x24()
  coll_gr()
end
--- --- ---
function pest_fn_A02_05() --Strings + Woodwinds
  pest_fn_A02_01()
  pest_fn_A02_03()
end
--- --- ---
function pest_fn_A02_06() --Brass Basic
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.saxophone )
  in_tr( tid , track.frenchhorns )
  in_tr( tid , track.tuba )
  in_tr( tid , track.trombones )
  in_tr( tid , track.trumpets )
  in_tr( tid , track.solobrass )
  in_gr( tid , group.brass )
  in_tr_gr_x6()
  coll_gr()
end
--- --- ---
function pest_fn_A02_07() --Brass Expanded
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.frenchhorns )
  in_tr( tid , track.frenchhorns )
  in_tr( tid , track.tuba )
  in_tr( tid , track.tuba )
  in_tr( tid , track.trombones )
  in_tr( tid , track.trombones )
  in_tr( tid , track.trumpets )
  in_tr( tid , track.trumpets )
  in_tr( tid , track.solobrass )
  in_tr( tid , track.solobrass )
  in_tr( tid , track.saxophone )
  in_tr( tid , track.saxophone )
  in_gr( tid , group.brass )
  in_tr_gr_x12()
  coll_gr()
end
--- --- ---
function pest_fn_A02_08() --Strings + Brass
  pest_fn_A02_01()
  pest_fn_A02_06()
end
--- --- ---
function pest_fn_A02_09() --Woodwinds + Brass
  pest_fn_A02_03()
  pest_fn_A02_06()
end
--- --- ---
function pest_fn_A02_10() --Keyboards Basic
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.accordion )
  in_tr( tid , track.celesta )
  in_tr( tid , track.harpsichord )
  in_tr( tid , track.organ )
  in_tr( tid , track.synthesizer )
  in_tr( tid , track.piano )
  in_tr( tid , track.harp )
  in_gr( tid , group.keyboards )
  in_tr_gr_x7()
  coll_gr()
end
--- --- ---
function pest_fn_A02_11() --Keyboards Expanded
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.accordion )
  in_tr( tid , track.accordion )
  in_tr( tid , track.celesta )
  in_tr( tid , track.celesta )
  in_tr( tid , track.harpsichord )
  in_tr( tid , track.harpsichord )
  in_tr( tid , track.organ )
  in_tr( tid , track.organ )
  in_tr( tid , track.synthesizer )
  in_tr( tid , track.synthesizer )
  in_tr( tid , track.piano )
  in_tr( tid , track.piano )
  in_tr( tid , track.harp )
  in_tr( tid , track.harp )
  in_gr( tid , group.keyboards )
  in_tr_gr_x14()
  coll_gr()
end
--- --- ---
function pest_fn_A02_12() --Keyboards + Strings
  pest_fn_A02_10()
  pest_fn_A02_01()
end
--- --- ---
function pest_fn_A02_13() --Keyboards + Woodwinds
  pest_fn_A02_10()
  pest_fn_A02_03()
end
--- --- ---
function pest_fn_A02_14() --Keyboards + Brass
  pest_fn_A02_10()
  pest_fn_A02_06()
end
--- --- ---
function pest_fn_A02_15() --Strings + Pianos
  pest_fn_A02_01()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.piano3 )
  in_tr( tid , track.piano2 )
  in_tr( tid , track.piano1 )
  in_gr( tid , group.pianos )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_16() --Woodwindws + Pianos
  pest_fn_A02_01()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.piano3 )
  in_tr( tid , track.piano2 )
  in_tr( tid , track.piano1 )
  in_gr( tid , group.pianos )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_17() --Brass + Pianos
  pest_fn_A02_01()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.piano3 )
  in_tr( tid , track.piano2 )
  in_tr( tid , track.piano1 )
  in_gr( tid , group.pianos )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_18(pn) --Triple Piano (Panning ±20)
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.pianor )
  song.selected_track.prefx_panning.value = 0.70 --(L = 0.00, C = 0.50 R = 1; 101 values)
  in_tr( tid , track.pianoc )
  in_tr( tid , track.pianol )
  song.selected_track.prefx_panning.value = 0.30
  in_gr( tid , group.pianos )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_19() --Synths + Pianos
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.synthesizer3 )
  in_tr( tid , track.synthesizer2 )
  in_tr( tid , track.synthesizer1 )
  in_gr( tid , group.synthesizers )
  in_tr_gr_x3()
  coll_gr()
  --
  local tid = song.selected_track_index
  in_tr( tid , track.piano3 )
  in_tr( tid , track.piano2 )
  in_tr( tid , track.piano1 )
  in_gr( tid , group.pianos )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_20() --Voices Basic
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.bassvoice )
  in_tr( tid , track.baritone )
  in_tr( tid , track.tenor )
  in_tr( tid , track.countertenor )
  in_tr( tid , track.contralto )
  in_tr( tid , track.mezzosoprano )
  in_tr( tid , track.soprano )
  in_gr( tid , group.voices )
  in_tr_gr_x7()
  coll_gr()
end
--- --- ---
function pest_fn_A02_21() --Voices Expanded
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.bassvoice )
  in_tr( tid , track.bassvoice )
  in_tr( tid , track.baritone )
  in_tr( tid , track.baritone )
  in_tr( tid , track.tenor )
  in_tr( tid , track.tenor )
  in_tr( tid , track.countertenor )
  in_tr( tid , track.countertenor )
  in_tr( tid , track.contralto )
  in_tr( tid , track.contralto )
  in_tr( tid , track.mezzosoprano )
  in_tr( tid , track.mezzosoprano )
  in_tr( tid , track.soprano )
  in_tr( tid , track.soprano )
  in_gr( tid , group.voices )
  in_tr_gr_x14()
  coll_gr()
end
--- --- ---
function pest_fn_A02_22() --Chorus Basic
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.childrenvoices )
  in_tr( tid , track.menvoices )
  in_tr( tid , track.womenvoices )
  in_tr( tid , track.mixedvoices )
  in_gr( tid , group.chorus )
  in_tr_gr_x4()
  coll_gr()
end
--- --- ---
function pest_fn_A02_23() --Chorus Expanded
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.childrenvoices )
  in_tr( tid , track.childrenvoices )
  in_tr( tid , track.menvoices )
  in_tr( tid , track.menvoices )
  in_tr( tid , track.womenvoices )
  in_tr( tid , track.womenvoices )
  in_tr( tid , track.mixedvoices )
  in_tr( tid , track.mixedvoices )
  in_gr( tid , group.chorus )
  in_tr_gr_x8()
  coll_gr()
end
--- --- ---
function pest_fn_A02_24() --Voices + Chorus
  pest_fn_A02_20()
  pest_fn_A02_22()
end
--- --- ---
function pest_fn_A02_25() --Percussion Basic
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.bassdrum )
  in_tr( tid , track.tenordrum )
  in_tr( tid , track.congas )
  in_tr( tid , track.timpani )
  in_tr( tid , track.gong )
  in_tr( tid , track.snaredrum )
  in_tr( tid , track.cymbals )
  --
  in_tr( tid , track.tambourine )
  in_tr( tid , track.claves )
  in_tr( tid , track.woodenblock )
  in_tr( tid , track.castanets )
  in_tr( tid , track.maracas )
  --
  in_tr( tid , track.chimes )
  in_tr( tid , track.triangle )
  in_tr( tid , track.hammer )
  in_tr( tid , track.marimba )
  in_tr( tid , track.glockenspiel )
  in_tr( tid , track.xylophone )
  in_tr( tid , track.vibraphone )
  in_tr( tid , track.tubularbells )
  in_gr( tid , group.percussion )
  in_tr_gr_x20()
  coll_gr()
end
--- --- ---
function pest_fn_A02_26() --Percussion Expanded I
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.chimes )
  in_tr( tid , track.chimes )
  in_tr( tid , track.triangle )
  in_tr( tid , track.triangle )
  in_tr( tid , track.hammer )
  in_tr( tid , track.hammer )
  in_tr( tid , track.marimba )
  in_tr( tid , track.marimba )
  in_tr( tid , track.glockenspiel )
  in_tr( tid , track.glockenspiel )
  in_tr( tid , track.xylophone )
  in_tr( tid , track.xylophone )
  in_tr( tid , track.vibraphone )
  in_tr( tid , track.vibraphone )
  in_tr( tid , track.tubularbells )
  in_tr( tid , track.tubularbells )
  in_gr( tid , group.percussion1 )
  in_tr_gr_x16()
  coll_gr()
end
--- --- ---
function pest_fn_A02_27() --Percussion Expanded II
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.tambourine )
  in_tr( tid , track.tambourine )
  in_tr( tid , track.claves )
  in_tr( tid , track.claves )
  in_tr( tid , track.woodenblock )
  in_tr( tid , track.woodenblock )
  in_tr( tid , track.castanets )
  in_tr( tid , track.castanets )
  in_tr( tid , track.maracas )
  in_tr( tid , track.maracas )
  in_gr( tid , group.percussion2 )
  in_tr_gr_x10()
  coll_gr()
end
--- --- ---
function pest_fn_A02_28() --Percussion Expanded III
  local song = renoise.song()
  local tid = song.selected_track_index
  in_tr( tid , track.bassdrum )
  in_tr( tid , track.bassdrum )
  in_tr( tid , track.tenordrum )
  in_tr( tid , track.tenordrum )
  in_tr( tid , track.congas )
  in_tr( tid , track.congas )
  in_tr( tid , track.timpani )
  in_tr( tid , track.timpani )
  in_tr( tid , track.gong )
  in_tr( tid , track.gong )
  in_tr( tid , track.snaredrum )
  in_tr( tid , track.snaredrum )
  in_tr( tid , track.cymbals )
  in_tr( tid , track.cymbals )
  in_gr( tid , group.percussion3 )
  in_tr_gr_x14()
  coll_gr()
end
--- --- ---
function pest_fn_A02_29()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_gr( tid , group.strings )
end
--- --- ---
function pest_fn_A02_30()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_gr( tid , group.woodwinds )
end
--- --- ---
function pest_fn_A02_31()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_gr( tid , group.brass )
end
--- --- ---
function pest_fn_A02_32()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_gr( tid , group.keyboards )
end
--- --- ---
function pest_fn_A02_33()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_gr( tid , group.voices )
end
--- --- ---
function pest_fn_A02_34()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_gr( tid , group.chorus )
end
--- --- ---
function pest_fn_A02_35()
  local song = renoise.song()
  local tid = song.selected_track_index
  in_gr( tid , group.percussion )
end

-----------------------------------------------------------------------------------

--Symphony Orchestra All
function pest_fn_A03_01() --
  pest_fn_A02_01()
  pest_fn_A02_03()
  pest_fn_A02_06()
  pest_fn_A02_10()
  pest_fn_A02_20()
  pest_fn_A02_22()
  pest_fn_A02_25()
end
--- --- ---
function pest_fn_A03_02()
  --content
  end
function pest_fn_A03_03()
  --content
end
function pest_fn_A03_04()
  --content
end
function pest_fn_A03_05()
  --content
  end
function pest_fn_A03_06()
  --content
end
function pest_fn_A03_07()
  --content
end


-----------------------------------------------------------------------------------

function pest_fn_B01_01()
  --content
end
function pest_fn_B01_02()
  --content
  end
function pest_fn_B01_03()
  --content
end
-----------------------------------------------------
function pest_fn_B02_01()
  --content
end
function pest_fn_B02_02()
  --content
  end
function pest_fn_B02_03()
  --content
end
-----------------------------------------------------
function pest_fn_B03_01()
  --content
end
function pest_fn_B03_02()
  --content
  end
function pest_fn_B03_03()
  --content
end
-----------------------------------------------------
function pest_fn_C01_01()
  --content
end
function pest_fn_C01_02()
  --content
  end
function pest_fn_C01_03()
  --content
end
-----------------------------------------------------
function pest_fn_C02_01()
  --content
end
function pest_fn_C02_02()
  --content
  end
function pest_fn_C02_03()
  --content
end
-----------------------------------------------------
function pest_fn_C03_01()
  --content
end
function pest_fn_C03_02()
  --content
  end
function pest_fn_C03_03()
  --content
end
-----------------------------------------------------
function pest_fn_D01_01()
  --content
end
function pest_fn_D01_02()
  --content
  end
function pest_fn_D01_03()
  --content
end
-----------------------------------------------------
function pest_fn_D02_01()
  --content
end
function pest_fn_D02_02()
  --content
  end
function pest_fn_D02_03()
  --content
end
-----------------------------------------------------
function pest_fn_D03_01()
  --content
end
function pest_fn_D03_02()
  --content
  end
function pest_fn_D03_03()
  --content
end
-----------------------------------------------------


STATUS = "GT16-Colors PEST:  your selected template has been inserted in Pattern Editor."
SELECT = "⚠ GT16-Colors PEST:  please, select before a option from the list!!!" 
WARTING = "⚠ GT16-Colors PEST:  please, select before a Track or Group in Pattern Editor, Pattern Matrix or Mixer!!!" 


--Group A (A01)
function pest_fn_A01( popup ) --( 62 of 70 )
  local app = renoise.app()
  if     popup == 1 then app:show_status( SELECT )
  elseif popup == 2 then app:show_status( SELECT )
  elseif popup == 3 then pest_fn_A01_01()
  elseif popup == 4 then pest_fn_A01_02()
  elseif popup == 5 then pest_fn_A01_03()
  elseif popup == 6 then pest_fn_A01_04()
  elseif popup == 7 then pest_fn_A01_05()
  elseif popup == 8 then pest_fn_A01_06()
  elseif popup == 9 then app:show_status( SELECT )
  elseif popup ==10 then pest_fn_A01_07()
  elseif popup ==11 then pest_fn_A01_08()
  elseif popup ==12 then pest_fn_A01_09()
  elseif popup ==13 then pest_fn_A01_10()
  elseif popup ==14 then pest_fn_A01_11()
  elseif popup ==15 then pest_fn_A01_12()
  elseif popup ==16 then pest_fn_A01_13()
  elseif popup ==17 then pest_fn_A01_14()
  elseif popup ==18 then pest_fn_A01_15()
  elseif popup ==19 then pest_fn_A01_16()
  elseif popup ==20 then pest_fn_A01_17()
  elseif popup ==21 then pest_fn_A01_18()
  elseif popup ==22 then pest_fn_A01_19()
  elseif popup ==23 then app:show_status( SELECT )
  elseif popup ==24 then pest_fn_A01_20()
  elseif popup ==25 then pest_fn_A01_21()
  elseif popup ==26 then pest_fn_A01_22()
  elseif popup ==27 then pest_fn_A01_23()
  elseif popup ==28 then pest_fn_A01_24()
  elseif popup ==29 then pest_fn_A01_25()
  elseif popup ==30 then app:show_status( SELECT )
  elseif popup ==31 then pest_fn_A01_26()
  elseif popup ==32 then pest_fn_A01_27()
  elseif popup ==33 then pest_fn_A01_28()
  elseif popup ==34 then pest_fn_A01_29()
  elseif popup ==35 then pest_fn_A01_30()
  elseif popup ==36 then pest_fn_A01_31()
  elseif popup ==37 then pest_fn_A01_32()
  elseif popup ==38 then app:show_status( SELECT )
  elseif popup ==39 then pest_fn_A01_33()
  elseif popup ==40 then pest_fn_A01_34()
  elseif popup ==41 then pest_fn_A01_35()
  elseif popup ==42 then pest_fn_A01_36()
  elseif popup ==43 then pest_fn_A01_37()
  elseif popup ==44 then pest_fn_A01_38()
  elseif popup ==45 then pest_fn_A01_39()
  elseif popup ==46 then app:show_status( SELECT )
  elseif popup ==47 then pest_fn_A01_40()
  elseif popup ==48 then pest_fn_A01_41()
  elseif popup ==49 then pest_fn_A01_42()
  elseif popup ==50 then pest_fn_A01_43()
  elseif popup ==51 then app:show_status( SELECT )
  elseif popup ==52 then pest_fn_A01_44()
  elseif popup ==53 then pest_fn_A01_45()
  elseif popup ==54 then pest_fn_A01_46()
  elseif popup ==55 then pest_fn_A01_47()
  elseif popup ==56 then pest_fn_A01_48()
  elseif popup ==57 then pest_fn_A01_49()
  elseif popup ==58 then pest_fn_A01_50()
  elseif popup ==59 then pest_fn_A01_51()
  elseif popup ==60 then pest_fn_A01_52()
  elseif popup ==61 then pest_fn_A01_53()
  elseif popup ==62 then pest_fn_A01_54()
  elseif popup ==63 then pest_fn_A01_55()
  elseif popup ==64 then pest_fn_A01_56()
  elseif popup ==65 then pest_fn_A01_57()
  elseif popup ==66 then pest_fn_A01_58()
  elseif popup ==67 then pest_fn_A01_59()
  elseif popup ==68 then pest_fn_A01_60()
  elseif popup ==69 then pest_fn_A01_61()
  elseif popup ==70 then pest_fn_A01_62()
  end
end
--Group A (A02)
function pest_fn_A02( popup ) --( 24 of 25 )
  local app = renoise.app()
  if     popup == 1 then app:show_status( SELECT )
  elseif popup == 2 then pest_fn_A02_01()
  elseif popup == 3 then pest_fn_A02_02()
  elseif popup == 4 then pest_fn_A02_03()
  elseif popup == 5 then pest_fn_A02_04()
  elseif popup == 6 then pest_fn_A02_05()
  elseif popup == 7 then pest_fn_A02_06()
  elseif popup == 8 then pest_fn_A02_07()
  elseif popup == 9 then pest_fn_A02_08()
  elseif popup ==10 then pest_fn_A02_09()
  elseif popup ==11 then pest_fn_A02_10()
  elseif popup ==12 then pest_fn_A02_11()
  elseif popup ==13 then pest_fn_A02_12()
  elseif popup ==14 then pest_fn_A02_13()
  elseif popup ==15 then pest_fn_A02_14()
  elseif popup ==16 then pest_fn_A02_15()
  elseif popup ==17 then pest_fn_A02_16()
  elseif popup ==18 then pest_fn_A02_17()
  elseif popup ==19 then pest_fn_A02_18()
  elseif popup ==20 then pest_fn_A02_19()
  elseif popup ==21 then pest_fn_A02_20()
  elseif popup ==22 then pest_fn_A02_21()
  elseif popup ==23 then pest_fn_A02_22()
  elseif popup ==24 then pest_fn_A02_23()
  elseif popup ==25 then pest_fn_A02_24()
  elseif popup ==26 then pest_fn_A02_25()
  elseif popup ==27 then pest_fn_A02_26()
  elseif popup ==28 then pest_fn_A02_27()
  elseif popup ==29 then pest_fn_A02_28()
  elseif popup ==30 then app:show_status( SELECT )
  elseif popup ==31 then pest_fn_A02_29()
  elseif popup ==32 then pest_fn_A02_30()
  elseif popup ==33 then pest_fn_A02_31()
  elseif popup ==34 then pest_fn_A02_32()
  elseif popup ==35 then pest_fn_A02_33()
  elseif popup ==36 then pest_fn_A02_34()
  elseif popup ==37 then pest_fn_A02_35()
  end
end
--Group A (A03)
function pest_fn_A03( popup ) -- ( 03 )
  local app = renoise.app()
  if     popup == 1 then app:show_status( SELECT )
  elseif popup == 2 then pest_fn_A03_01()
  elseif popup == 3 then pest_fn_A03_02()
  elseif popup == 2 then pest_fn_A03_03()
  end
end


--- --- --- ---
--Group B
function pest_fn_B01( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_B01_01()
  elseif popup == 2 then pest_fn_B01_02()
  elseif popup == 3 then pest_fn_B01_03()
  end
end

function pest_fn_B02( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_B02_01()
  elseif popup == 2 then pest_fn_B02_02()
  elseif popup == 3 then pest_fn_B02_03()
  end
end

function pest_fn_B03( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_B03_01()
  elseif popup == 2 then pest_fn_B03_02()
  elseif popup == 3 then pest_fn_B03_03()
  end
end


--Group C
function pest_fn_C01( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_C01_01()
  elseif popup == 2 then pest_fn_C01_02()
  elseif popup == 3 then pest_fn_C01_03()
  end
end

function pest_fn_C02( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_C02_01()
  elseif popup == 2 then pest_fn_C02_02()
  elseif popup == 3 then pest_fn_C02_03()
  end
end

function pest_fn_C03( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_C03_01()
  elseif popup == 2 then pest_fn_C03_02()
  elseif popup == 3 then pest_fn_C03_03()
  end
end


--Group D
function pest_fn_D01( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_D01_01()
  elseif popup == 2 then pest_fn_D01_02()
  elseif popup == 3 then pest_fn_D01_03()
  end
end

function pest_fn_D02( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_D02_01()
  elseif popup == 2 then pest_fn_D02_02()
  elseif popup == 3 then pest_fn_D02_03()
  end
end

function pest_fn_D03( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_D03_01()
  elseif popup == 2 then pest_fn_D03_02()
  elseif popup == 3 then pest_fn_D03_03()
  end
end


--------------------------------------------------------------------------------
-- BUTTON INSERT FUNCTIONS OF POPUPS
--------------------------------------------------------------------------------

--Group A
function pest_A01()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_A01 ( PEST_PP_A01.value )
    else renoise.app():show_status( WARTING )
  end
end

function pest_A02()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_A02 ( PEST_PP_A02.value )
    else renoise.app():show_status( WARTING )
  end
end

function pest_A03()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_A03 ( PEST_PP_A03.value )
    else renoise.app():show_status( WARTING )
  end
end
--Group B
function pest_B01()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_B01 ( PEST_PP_B01.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_B02()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_B02 ( PEST_PP_B02.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_B03()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_B03 ( PEST_PP_B03.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end
--Group C
function pest_C01()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_C01 ( PEST_PP_C01.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_C02()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_C02 ( PEST_PP_C02.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_C03()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_C03 ( PEST_PP_C03.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end
--Group D
function pest_D01()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_D01 ( PEST_PP_D01.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_D02()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_D02 ( PEST_PP_D02.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_D03()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_D03 ( PEST_PP_D03.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end
--Group E
function pest_E01()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_E01 ( PEST_PP_E01.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_E02()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_E02 ( PEST_PP_E02.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_E03()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_E03 ( PEST_PP_E03.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end
--Group F
function pest_F01()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_F01 ( PEST_PP_F01.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_F02()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_F02 ( PEST_PP_F02.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_F03()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_F03 ( PEST_PP_F03.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end


--------------------------------------------------------------------------------
-- PRINCIPAL POPUPS
--------------------------------------------------------------------------------
--Group A
PEST_PP_A01 = vb:popup { id = 'PEST_PP_A01', width = 198 , height = 24, value = 1, items = {
    ' ORCHESTRA INSTRUMENTS ↷',
    '  Strings ↷',
    '     01. Solo String',
    '     02. First Violins',
    '     03. Second Violins',
    '     04. Violas',
    '     05. Cellos',
    '     06. Basses',
    '  Woodwinds ↷',
    '     01. Solo Woodwind',
    '     02. Flute',
    '     03. Oboe',
    '     04. Piccolo',
    '     05. English Horn',
    '     06. Bass Clarinet',
    '     07. Clarinet',
    '     08. Contrabasson',
    '     09. Basson',
    '     10. Bagpipe',
    '     11. Shakuhachi',
    '     12. Cornet',
    '     13. Harmonica',
    '  Brass ↷',
    '     01. Solo Brass',
    '     02. Trumpets',
    '     03. Trombones',
    '     04. Tuba',
    '     05. French Horns',
    '     06. Saxophone',
    '  Keyboards ↷',
    '     01. Harp',
    '     02. Piano',
    '     03. Synthesizer',
    '     04. Organ',
    '     05. Harpsichord',
    '     06. Celesta',
    '     07. Accordion',
    '  Voices ↷',
    '     01. Soprano',
    '     02. Mezzo-Soprano',
    '     03. Alto (Voice)',
    '     04. Countertenor',
    '     05. Tenor',
    '     06. Baritone',
    '     07. Bass (Voice)',
    '  Chorus ↷',
    '     01. Mixed Voices',
    '     02. Women Voices',
    '     03. Men Voices',
    '     04. Children Voices',
    '  Percussion ↷',
    '     01. Tubular Bells',
    '     02. Vibraphone',
    '     03. Xylophone',
    '     04. Glockenspiel',
    '     05. Marimba',
    '     06. Hammer',
    '     07. Triangle',
    '     08. Chimes',
    '     09. Maracas',
    '     10. Castanets',
    '     11. Wooden-block',
    '     12. Claves',
    '     13. Tambourine',
    '     14. Cymbals',
    '     15. Snare Drum',
    '     16. Gong',
    '     17. Timpani',
    '     18. Congas',
    '     19. Tenor Drum',
    '     20. Bass Drum'
  }
}
PEST_PP_A02 = vb:popup { id = 'PEST_PP_A02', width = 198 , height = 24, value = 1, items = {
    ' ORCHESTRA SECTIONS ↷',
    '    01. Strings Basic',
    '    02. Strings Expanded',
    '    03. Woodwinds Basic',    
    '    04. Woodwinds Expanded',
    '    05. Strings + Woodwinds',
    '    06. Brass Basic',
    '    07. Brass Expanded',
    '    08. Strings + Brass',
    '    09. Woodwinds + Brass',
    '    10. Keyboards Basic',
    '    11. Keyboards Expanded',
    '    12. Keyboards + Strings',
    '    13. Keyboards + Woodwinds',
    '    14. Keyboards + Brass',
    '    15. Strings + Pianos',
    '    16. Woodwinds + Pianos',
    '    17. Brasses + Pianos',
    '    18. Triple Piano (Panning ±20)',
    '    19. Synths + Pianos',
    '    20. Voices Basic',
    '    21. Voices Expanded',
    '    22. Chorus Basic',
    '    23. Chorus Expannded',
    '    24. Voices + Chorus',
    '    25. Percussion Basic',
    '    26. Percussion Expanded I',
    '    27. Percussion Expanded II',
    '    28. Percussion Expanded III',
    ' ORCHESTRA SECTIONS (Empty) ↷',
    '    01. Strings Group',
    '    02. Woodwinds Group',
    '    03. Brass Group',
    '    04. Keyboards Group',
    '    05. Voices Group',
    '    06. Chorus Group',
    '    07. Percussion Group',
  }
} 
PEST_PP_A03 = vb:popup { id = 'PEST_PP_A03', width = 198 , height = 24, value = 1, items = {
    ' SYMPHONY ORCHESTRA ↷',
    '    01. SO Little',
    '    02. SO Median',
    '    03. SO Big',    
    '    04. SO + Voices',
    '    05. SO + Etnic Perc.',
    '    06. SO + Ambient Synth',
    '    07. SO + Triple Piano'
  }
}

--Group B
PEST_PP_B01 = vb:popup { id = 'PEST_PP_B01', width = 198 , height = 24, value = 1, items = {
    ' BAND INSTRUMENTS ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
}  
PEST_PP_B02 = vb:popup { id = 'PEST_PP_B02', width = 198 , height = 24, value = 1, items = {
    ' BAND SECTIONS ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
} 
PEST_PP_B03 = vb:popup { id = 'PEST_PP_B03', width = 198 , height = 24, value = 1, items = {
    ' BAND POP/ROCK/HEAVY ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
}

--Group C
PEST_PP_C01 = vb:popup { id = 'PEST_PP_C01', width = 198 , height = 24, value = 1, items = {
    ' ELECTRONIC INSTRUMENTS ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
}  

PEST_PP_C02 = vb:popup { id = 'PEST_PP_C02', width = 198 , height = 24, value = 1, items = {
    ' ELECTRONIC SECTIONS ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
}
PEST_PP_C03 = vb:popup { id = 'PEST_PP_C03', width = 198 , height = 24, value = 1, items = {
    ' ELECTRONIC/NEW AGE ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
}

--Group D
PEST_PP_D01 = vb:popup { id = 'PEST_PP_D01', width = 198 , height = 24, value = 1, items = {
    ' OTHER INSTRUMENTS ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
}  
PEST_PP_D02 = vb:popup { id = 'PEST_PP_D02', width = 198 , height = 24, value = 1, items = {
    ' OTHER SECTIONS ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
} 
PEST_PP_D03 = vb:popup { id = 'PEST_PP_D03', width = 198 , height = 24, value = 1, items = {
    ' OTHER STYLES ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
}

--[[

--Group E
PEST_PP_E01 = vb:popup { id = 'PEST_PP_E01', width = 198 , height = 24, value = 1, items = {
    ' 01. Exxx ' ,
    ' 02. Eyyy ' ,
    ' 03. Ezzz '
  }
}  
PEST_PP_E02 = vb:popup { id = 'PEST_PP_E02', width = 198 , height = 24, value = 1, items = {
    ' 01. Exxx ' ,
    ' 02. Eyyy ' ,
    ' 03. Ezzz '
  }
} 
PEST_PP_E03 = vb:popup { id = 'PEST_PP_E03', width = 198 , height = 24, value = 1, items = {
    ' 01. Exxx ' ,
    ' 02. Eyyy ' ,
    ' 03. Ezzz '
  }
}

--Group F
PEST_PP_F01 = vb:popup { id = 'PEST_PP_F01', width = 198 , height = 24, value = 1, items = {
    ' 01. Fxxx ' ,
    ' 02. Fyyy ' ,
    ' 03. Fzzz '
  }
}  
PEST_PP_F02 = vb:popup { id = 'PEST_PP_F02', width = 198 , height = 24, value = 1, items = {
    ' 01. Fxxx ' ,
    ' 02. Fyyy ' ,
    ' 03. Fzzz '
  }
} 
PEST_PP_F03 = vb:popup { id = 'PEST_PP_F03', width = 198 , height = 24, value = 1, items = {
    ' 01. Fxxx ' ,
    ' 02. Fyyy ' ,
    ' 03. Fzzz '
  }
}

]]

--------------------------------------------------------------------------------
-- PRINCIPAL BUTTONS
--------------------------------------------------------------------------------
PEST.CR = {
  --Group A
  BT_A01 = { 0x00,0x40,0x70 },
  BT_A02 = { 0x00,0x40,0x70 },
  BT_A03 = { 0x00,0x40,0x70 },
  --Group B
  BT_B01 = { 0x00,0x40,0x70 },
  BT_B02 = { 0x00,0x40,0x70 },
  BT_B03 = { 0x00,0x40,0x70 },
  --Group C
  BT_C01 = { 0x00,0x40,0x70 },
  BT_C02 = { 0x00,0x40,0x70 },
  BT_C03 = { 0x00,0x40,0x70 },
  --Group D
  BT_D01 = { 0x00,0x40,0x70 },
  BT_D02 = { 0x00,0x40,0x70 },
  BT_D03 = { 0x00,0x40,0x70 },
  --Group E
  BT_E01 = { 0x00,0x40,0x70 },
  BT_E02 = { 0x00,0x40,0x70 },
  BT_E03 = { 0x00,0x40,0x70 },
  --Group F
  BT_F01 = { 0x00,0x40,0x70 },
  BT_F02 = { 0x00,0x40,0x70 },
  BT_F03 = { 0x00,0x40,0x70 }
}

--Group A
PEST_BT_A01 = vb:button {
  id = 'PEST_BT_A01',
  tooltip = 'Insert A01',
  text = '+',
  color = PEST.CR.BT_A01,
  width = 24,
  height = 24,
  notifier = function()pest_A01() end
}
PEST_BT_A02 = vb:button {
  id = 'PEST_BT_A02',
  tooltip = 'Insert A02',
  text = '+',
  color = PEST.CR.BT_A02,
  width = 24,
  height = 24,
  notifier = function()pest_A02() end
}
PEST_BT_A03 = vb:button {
  id = 'PEST_BT_A03',
  tooltip = 'Insert A03',
  text = '+',
  color = PEST.CR.BT_A03,
  width = 24,
  height = 24,
  notifier = function()pest_A03() end
}

--Group B
PEST_BT_B01 = vb:button {
  id = 'PEST_BT_B01',
  tooltip = 'Insert B01',
  text = '+',
  color = PEST.CR.BT_B01,
  width = 24,
  height = 24,
  notifier = function()pest_B01() end
}
PEST_BT_B02 = vb:button {
  id = 'PEST_BT_B02',
  tooltip = 'Insert B02',
  text = '+',
  color = PEST.CR.BT_B02,
  width = 24,
  height = 24,
  notifier = function()pest_B02() end
}
PEST_BT_B03 = vb:button {
  id = 'PEST_BT_B03',
  tooltip = 'Insert B03',
  text = '+',
  color = PEST.CR.BT_B03,
  width = 24,
  height = 24,
  notifier = function()pest_B03() end
}

--Group C
PEST_BT_C01 = vb:button {
  id = 'PEST_BT_C01',
  tooltip = 'Insert C01',
  text = '+',
  color = PEST.CR.BT_C01,
  width = 24,
  height = 24,
  notifier = function()pest_C01() end
}
PEST_BT_C02 = vb:button {
  id = 'PEST_BT_C02',
  tooltip = 'Insert C02',
  text = '+',
  color = PEST.CR.BT_C02,
  width = 24,
  height = 24,
  notifier = function()pest_C02() end
}
PEST_BT_C03 = vb:button {
  id = 'PEST_BT_C03',
  tooltip = 'Insert C03',
  text = '+',
  color = PEST.CR.BT_C03,
  width = 24,
  height = 24,
  notifier = function()pest_C03() end
}

--Group D
PEST_BT_D01 = vb:button {
  id = 'PEST_BT_D01',
  tooltip = 'Insert D01',
  text = '+',
  color = PEST.CR.BT_D01,
  width = 24,
  height = 24,
  notifier = function()pest_D01() end
}
PEST_BT_D02 = vb:button {
  id = 'PEST_BT_D02',
  tooltip = 'Insert D02',
  text = '+',
  color = PEST.CR.BT_D02,
  width = 24,
  height = 24,
  notifier = function()pest_D02() end
}
PEST_BT_D03 = vb:button {
  id = 'PEST_BT_D03',
  tooltip = 'Insert D03',
  text = '+',
  color = PEST.CR.BT_D03,
  width = 24,
  height = 24,
  notifier = function()pest_D03() end
}

--Group E
PEST_BT_E01 = vb:button {
  id = 'PEST_BT_E01',
  tooltip = 'Insert E01',
  text = '+',
  color = PEST.CR.BT_E01,
  width = 24,
  height = 24,
  notifier = function()pest_E01() end
}
PEST_BT_E02 = vb:button {
  id = 'PEST_BT_E02',
  tooltip = 'Insert E02',
  text = '+',
  color = PEST.CR.BT_E02,
  width = 24,
  height = 24,
  notifier = function()pest_E02() end
}
PEST_BT_E03 = vb:button {
  id = 'PEST_BT_E03',
  tooltip = 'Insert E03',
  text = '+',
  color = PEST.CR.BT_E03,
  width = 24,
  height = 24,
  notifier = function()pest_E03() end
}

--Group F
PEST_BT_F01 = vb:button {
  id = 'PEST_BT_F01',
  tooltip = 'Insert F01',
  text = '+',
  color = PEST.CR.BT_F01,
  width = 24,
  height = 24,
  notifier = function()pest_F01() end
}
PEST_BT_F02 = vb:button {
  id = 'PEST_BT_F02',
  tooltip = 'Insert F02',
  text = '+',
  color = PEST.CR.BT_F02,
  width = 24,
  height = 24,
  notifier = function()pest_F02() end
}
PEST_BT_F03 = vb:button {
  id = 'PEST_BT_F03',
  tooltip = 'Insert F03',
  text = '+',
  color = PEST.CR.BT_F03,
  width = 24,
  height = 24,
  notifier = function()pest_F03() end
}


--------------------------------------------------------------------------------
-- GUI PEST TOOL
--------------------------------------------------------------------------------
PEST =
vb:column {
  width = 680,
  vb:horizontal_aligner {
    mode = 'center',
    vb:text { font = 'big', text = '⚡ ' },
    vb:text { font = 'bold', text = 'PEST: Pattern Editor Specific Templates' },
    vb:text { text = '   v1.0b' }
  },
  vb:horizontal_aligner {
    vb:horizontal_aligner {
      mode = 'center',
      width = 200,
      vb:text { text = 'Individual' }
    },
    vb:horizontal_aligner {
      mode = 'center',
      width = 250,
      vb:text { text = 'Groups' }
    },
    vb:horizontal_aligner {
      mode = 'center',
      width = 215,
      vb:text { text = 'Styles' }
    },
  },
  vb:horizontal_aligner {
    PEST_PP_A01, PEST_BT_A01,
    vb:horizontal_aligner { width = 6 },
    PEST_PP_A02, PEST_BT_A02,
    vb:horizontal_aligner { width = 6 },
    PEST_PP_A03, PEST_BT_A03
  },
  --- ---
  vb:horizontal_aligner { height = 4 },
  vb:horizontal_aligner {
    PEST_PP_B01, PEST_BT_B01,
    vb:horizontal_aligner { width = 6 },
    PEST_PP_B02, PEST_BT_B02,
    vb:horizontal_aligner { width = 6 },
    PEST_PP_B03, PEST_BT_B03
  },
  --- ---
  vb:horizontal_aligner { height = 4 },
  vb:horizontal_aligner {
    PEST_PP_C01, PEST_BT_C01,
    vb:horizontal_aligner { width = 6 },
    PEST_PP_C02, PEST_BT_C02,
    vb:horizontal_aligner { width = 6 },
    PEST_PP_C03, PEST_BT_C03
  },
  --- ---
  vb:horizontal_aligner { height = 4 },
  vb:horizontal_aligner {
    PEST_PP_D01, PEST_BT_D01,
    vb:horizontal_aligner { width = 6 },
    PEST_PP_D02, PEST_BT_D02,
    vb:horizontal_aligner { width = 6 },
    PEST_PP_D03, PEST_BT_D03
  },
  vb:horizontal_aligner { height = 6 },
  vb:column {
    width = 678,
    vb:horizontal_aligner {
      mode = 'right',
      DEFAULT_PEST_PARAM,
      vb:horizontal_aligner { width = 6 },
      vb:button {
        active = false,
        width = 32,
        height = 22,
        --color = { 0x06,0x0B,0x40 },
        text = 'NOT',
      },
      VALUEBOX_PEST_TRNTC,
      vb:horizontal_aligner { width = 6 },
      BUTTONCHECK_PEST_TRVOL,
      BUTTONCHECK_PEST_TRPAN,
      BUTTONCHECK_PEST_TRDLY,
      BUTTONCHECK_PEST_TRSFX,
      vb:horizontal_aligner { width = 6 },
      VALUEBOX_PEST_TRFXT,
      vb:button {
        active = false,
        width = 32,
        height = 22,
        --color = { 0x06,0x0B,0x40 },
        text = 'FXt',
      },
    }
  }
}
