--------------------------------------------------------------------------------
-- Module Tool: Tool_02.lua
-- Name: PMSS: Pattern Matrix Specific Sequencer
-- Version: 1.0b
-- Author: ulneiz (Spain)
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- FUNCTIONS
--------------------------------------------------------------------------------
--Number of Lines
function pmss_number_of_lines( song, i )
  song = renoise.song()
  if vb.views['PMSS_CB_NO_LINES'].value == true then
    local pattern = song:pattern( song.selected_sequence_index )    
    pattern.number_of_lines = vb.views['PMSS_VB_NO_LINES'].value --96
  end
end

--Include sequence
function pmss_multiple_sequencer( song, sid, name_section, i, m, n )
  song = renoise.song()
  m = vb.views['PMSS_VB_MULTIPLY'].value --value of multiplier
  n = vb.views['PMSS_VB_NUMBER'].value --value of number
  for i = 1, m do  
    sid = song.selected_sequence_index
    if vb.views['PMSS_CB_SECTION'].value == true then --include name of section
      name_section = vb.views['PMSS_TF_TEXT'].text
      song.sequencer:set_sequence_is_start_of_section( sid, true ) --start of section
      song.sequencer:set_sequence_section_name(sid, name_section ) --name of section
      else
    end
    for i = 1, n do --number of patterns for section
      i = sid + 1
      song.sequencer:insert_new_pattern_at( i ) --insert 'n' patterns
      song.selected_sequence_index = song.selected_sequence_index + 1 -- #song.sequencer.pattern_sequence --jump last sequence
      pmss_number_of_lines()
    end
  end
  song.sequencer:sort() --sort sequence
  if vb.views['PMSS_VB_NUMBER'].value == 0 then --Number of Lines in selected pattern
    pmss_number_of_lines()
  end
end

--------------------------------------------------------------------------------
-- OBJECTS
--------------------------------------------------------------------------------
--Name of section through 'number'
function pmss_fn_number( value, m, n )
  m = vb.views['PMSS_VB_MULTIPLY'].value --value of multiplier
  n = vb.views['PMSS_VB_NUMBER'].value --value of number
  value = vb.views['PMSS_VB_NUMBER'].value
  if value == 0 then
    vb.views['PMSS_TF_TEXT'].text = "'00' only change the name of section!"
  end
  if value >= 1 then
    vb.views['PMSS_TF_TEXT'].text = 'SECTION x'..value..' Patterns'
    --vb.views['PMSS_TX_TOTAL'].text = 'Patterns: '..n * m..''
  end
end

--Name of section through 'label'
function pmss_fn_section( value )
  value = vb.views['PMSS_PP_SECTION'].value
  if value == 1 then vb.views['PMSS_TF_TEXT'].text = 'START SONG' end
  if value == 2 then vb.views['PMSS_TF_TEXT'].text = 'INTRODUCTION' end
  if value == 3 then vb.views['PMSS_TF_TEXT'].text = 'CLOSING' end
  if value == 4 then vb.views['PMSS_TF_TEXT'].text = 'END SOUND' end
  if value == 5 then vb.views['PMSS_TF_TEXT'].text = 'MAIN THEME' end
  if value == 6 then vb.views['PMSS_TF_TEXT'].text = 'SECONDARY THEME' end
  if value == 7 then vb.views['PMSS_TF_TEXT'].text = 'TERTIARY THEME' end
  if value == 8 then vb.views['PMSS_TF_TEXT'].text = 'ALTERNATIVE THEME' end
  if value == 9 then vb.views['PMSS_TF_TEXT'].text = 'CHANGE OF COMPASS' end
  if value ==10 then vb.views['PMSS_TF_TEXT'].text = 'MARKER' end
  if value ==11 then vb.views['PMSS_TF_TEXT'].text = 'REPEAT' end
  if value ==12 then vb.views['PMSS_TF_TEXT'].text = 'CRESCENT' end
  if value ==13 then vb.views['PMSS_TF_TEXT'].text = 'DECREASING' end
  if value ==14 then vb.views['PMSS_TF_TEXT'].text = 'CALM' end
  if value ==15 then vb.views['PMSS_TF_TEXT'].text = 'FORCE' end
  if value ==16 then vb.views['PMSS_TF_TEXT'].text = 'VERSE' end
  if value ==17 then vb.views['PMSS_TF_TEXT'].text = 'CHORUS' end
  if value ==18 then vb.views['PMSS_TF_TEXT'].text = 'BRIDGE' end
  if value ==19 then vb.views['PMSS_TF_TEXT'].text = 'FUSION' end
  if value ==20 then vb.views['PMSS_TF_TEXT'].text = 'JUMP' end
  if value ==21 then vb.views['PMSS_TF_TEXT'].text = 'CUT' end
  
end

--Number
PMSS_VB_NUMBER = vb:valuebox { id = 'PMSS_VB_NUMBER', width = 54, height = 22, min = 0, max = 16, value = 4,
  notifier = function() pmss_fn_number() end, tooltip ="Number of patterns for the section to insert.\n[Range = 0-16. Default Value = 4]\n'00' Value only change the name of section, does not insert patterns!"
}
PMSS_BT_02 = vb:button { id = 'PMSS_BT_02', width = 26, height = 22, text = '2', notifier = function() vb.views['PMSS_VB_NUMBER'].value = 2 end, tooltip = '2 Patterns.' }
PMSS_BT_04 = vb:button { id = 'PMSS_BT_04', width = 26, height = 22, text = '4', notifier = function() vb.views['PMSS_VB_NUMBER'].value = 4 end, tooltip = '4 Patterns.' }
PMSS_BT_06 = vb:button { id = 'PMSS_BT_06', width = 26, height = 22, text = '6', notifier = function() vb.views['PMSS_VB_NUMBER'].value = 6 end, tooltip = '6 Patterns.' }
PMSS_BT_08 = vb:button { id = 'PMSS_BT_08', width = 26, height = 22, text = '8', notifier = function() vb.views['PMSS_VB_NUMBER'].value = 8 end, tooltip = '8 Patterns.' }

--Name of Section (Label)
PMSS_PP_SECTION = vb:popup { id = 'PMSS_PP_SECTION', width = 150, height = 22, value = 1, notifier = function() pmss_fn_section() end, tooltip = 'Select a predefined name of section.',
  items = { ' Start Song',' Introduction',' Closing',' End Sound',' Main Theme',' Secondary Theme',' Tertiary Theme',' Alternative Theme',' Change of Compass',
            ' Marker',' Repeat',' Crescent',' Decreasing',' Calm',' Force',' Verse',' Chorus',' Bridge',' Fusion',' Jump', ' Cut'
  }
}
PMSS_CB_SECTION = vb:checkbox { id = 'PMSS_CB_SECTION', value = true, tooltip = 'Enable/disable the insertion of the Name of Section.\n[Default = Enabled]' }
PMSS_TF_TEXT = vb:textfield { id = 'PMSS_TF_TEXT', width = 210, height = 22, text = 'Name of Section', align = 'center', tooltip = 'Modify the Name of Section manually.' }

--Multiplier
PMSS_VB_MULTIPLY = vb:valuebox { id = 'PMSS_VB_MULTIPLY', width = 54, height = 22, min = 1, max = 16, value = 1, notifier = function() end, tooltip = 'Multiplier for section.\n[Range = x1-x16. Default Value = x1]' }
PMSS_BT_X02 = vb:button { id = 'PMSS_BT_X02', width = 32, height = 22, text = 'x2', notifier = function() vb.views['PMSS_VB_MULTIPLY'].value = 2 end, tooltip = 'Multiplier = x2.' }
PMSS_BT_X04 = vb:button { id = 'PMSS_BT_X04', width = 32, height = 22, text = 'x4', notifier = function() vb.views['PMSS_VB_MULTIPLY'].value = 4 end, tooltip = 'Multiplier = x4.' }
PMSS_BT_X06 = vb:button { id = 'PMSS_BT_X06', width = 32, height = 22, text = 'x6', notifier = function() vb.views['PMSS_VB_MULTIPLY'].value = 6 end, tooltip = 'Multiplier = x6.' }
PMSS_BT_X08 = vb:button { id = 'PMSS_BT_X08', width = 32, height = 22, text = 'x8', notifier = function() vb.views['PMSS_VB_MULTIPLY'].value = 8 end, tooltip = 'Multiplier = x8.' }
PMSS_BT_X10 = vb:button { id = 'PMSS_BT_X10', width = 32, height = 22, text ='x10' ,notifier = function() vb.views['PMSS_VB_MULTIPLY'].value =10 end, tooltip = 'Multiplier = x10.' }
PMSS_BT_X12 = vb:button { id = 'PMSS_BT_X12', width = 32, height = 22, text ='x12' ,notifier = function() vb.views['PMSS_VB_MULTIPLY'].value =12 end, tooltip = 'Multiplier = x12.' }

--Number of Lines
PMSS_CB_NO_LINES = vb:checkbox { id = 'PMSS_CB_NO_LINES', value = false, tooltip = 'Enable/disable the Number of Lines per pattern.\n[Default = Disabled]' }
PMSS_VB_NO_LINES = vb:valuebox { id = 'PMSS_VB_NO_LINES', width = 54, height = 22, min = 1, max = 512, value = 96, notifier = function() end, tooltip = 'Number of Lines per pattern.\n[Rangue = 1-512. Default Value = 96]' }

--Total Patterns & Duration
PMSS_TX_TOTAL = vb:text { id = 'PMSS_TX_TOTAL', height = 22, text = 'Patterns: xxx' }
PMSS_TX_DURATION = vb:text { id = 'PMSS_TX_DURATION', height = 22, text = 'Duration: xx min' }

--Button Apply
PMSS_BT_APPLY = vb:horizontal_aligner { width = 83, mode = 'right',
  vb:button { id = 'PMSS_BT_APPLY', width = 78, height = 54, color = { 0x00,0x40,0x00 }, text = 'Apply\nSequence!', notifier = function() pmss_multiple_sequencer() end }
}


--------------------------------------------------------------------------------
-- GUI - PMSS
--------------------------------------------------------------------------------
PMSS =
vb:column {
 -- width = 680,
  vb:horizontal_aligner {
    mode = 'center',
    vb:text { font = 'big', text = '⚡ ' },
    vb:text { font = 'bold', text = 'PMSS: Pattern Matrix Specific Sequencer' },
    vb:text { text = '   v1.0b' }
  },
  vb:horizontal_aligner { height = 5 },
  vb:row{
    vb:column { style = 'panel', margin = 5,
      vb:row{
        vb:column {
          vb:text { text = 'Number', height = 22 }, PMSS_VB_NUMBER
        },
        vb:column {
          PMSS_BT_02, PMSS_BT_04
        },
        vb:column {
          PMSS_BT_06, PMSS_BT_08
        }
      }
    },
    vb:column { style = 'panel', margin = 5,
      vb:row { 
        vb:text { text = 'Change Label', width = 78 },
        PMSS_PP_SECTION }, vb:row { PMSS_CB_SECTION, PMSS_TF_TEXT }
    },
    vb:column { style = 'panel', margin = 5,
      vb:row{
        vb:column {
          vb:text { text = 'Multiplier', height = 22 }, PMSS_VB_MULTIPLY
        },
        vb:column {
          PMSS_BT_X02, PMSS_BT_X04
        },
        vb:column {
          PMSS_BT_X06, PMSS_BT_X08
        },
        vb:column {
          PMSS_BT_X10, PMSS_BT_X12
        }
      }
    },
    vb:column { style = 'panel', margin = 5,
    vb:text { text = 'Lines', height = 22 },
    vb:row { PMSS_CB_NO_LINES, PMSS_VB_NO_LINES },
    },
   -- vb:column { style = 'panel', margin = 5,
   --   PMSS_TX_TOTAL, PMSS_TX_DURATION
   -- },
    PMSS_BT_APPLY,
  }
}
